//------------------------------------------------------------------------------------------------------
//̸ : e_image.cpp
//ҽ ۼ : PSG-01 a.k.a Pusungwi (opeth@teramail.com)
// ģ : 2007 1 16
//ҽ  : ̷Ʈ ο츦 ̿ ̽, Ʈ  Ÿ ̴.
//------------------------------------------------------------------------------------------------------

#include <ddraw.h>

#include "e_main.h"	        //prototype   
#include "e_image.h"
#include "e_global.h"

//---------------------------------------------------
//initsurface Լ ̽  ʱȭ Ų, 
//ɼ ߰ش.
//---------------------------------------------------

BOOL initsurface()
{
	DDSURFACEDESC2 ddsd;
	DDSCAPS2 ddscaps;
	HRESULT ddrval;

	if(BackSurface){//鼭̽ Ǿ ִٸ ع
		BackSurface->Release();
		BackSurface=NULL;
	}	
	
	if(MainSurface){//̸Ӹ ̽ Ǿ ִٸ ع
		MainSurface->Release();
		MainSurface=NULL;
	}
	
	memset((VOID *) &ddsd, 0, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);	
	ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX;
	ddsd.dwBackBufferCount = 1;
	ddrval = dd->CreateSurface(&ddsd, &MainSurface, NULL);
	if(ddrval != DD_OK)	return DrawFail();	

	ZeroMemory(&ddscaps, sizeof(ddscaps));
	ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
	ddrval = MainSurface->GetAttachedSurface(&ddscaps, &BackSurface);
	if(ddrval != DD_OK) return DrawFail();	

	return TRUE;
}

//---------------------------------------------------
//initobject Լ ̽  ǿ ʱȭ ⼭ 
// ó,  ʱȭ   Ʈ
//عѴ
//---------------------------------------------------

BOOL initobject(HWND hwnd)
{
	HRESULT ddrval;
	ddrval = DirectDrawCreateEx(NULL, (void**)&dd, IID_IDirectDraw7, NULL);
	if(ddrval != DD_OK)	return DrawFail();
	
	ncoop = DDSCL_EXCLUSIVE|DDSCL_FULLSCREEN;

	ddrval = dd->SetCooperativeLevel(hwnd, ncoop);	
	if(ddrval != DD_OK)	return DrawFail();

	SetWindowLong(hwnd, GWL_STYLE, WS_POPUP);

	ddrval = dd->SetDisplayMode(640, 480, 32, 0, 0);
	if(ddrval != DD_OK)	return DrawFail();
	
	return TRUE;
}

LPDIRECTDRAWSURFACE7 loadbmp(char* filename, int bmpwidth, int bmpheight)
{	//Ʈ  Ϸκ о鿩
	HBITMAP	hbm;
	hbm=(HBITMAP) LoadImage(NULL, filename, IMAGE_BITMAP, bmpwidth, bmpheight, // bmpwidth, bmpheight   ʺ ޾ƿͼ ǥִ  
				LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	if(!hbm)		return	NULL;
	//Ʈ  Ʈ  
	BITMAP	bm;
	GetObject(hbm, sizeof(bm), &bm);	//̽ ۼ
	LPDIRECTDRAWSURFACE7	surface;

	ZeroMemory(&surface, sizeof(surface));
	surface=create_surface(bmpwidth, bmpheight,
			DDSCAPS_OFFSCREENPLAIN|DDSCAPS_SYSTEMMEMORY);
	if(!surface)		return	NULL;
	// ȭ  ȣȯ ִ ޸𸮵̽ؽƮ ۼ.
	HDC	hdcbmp;
	if(!(hdcbmp=CreateCompatibleDC(NULL)))
	{
		surface->Release();
		return	NULL;
	}

	//hdcimage Ʈ  
	SelectObject(hdcbmp, hbm);//̽κ HDC 
	HDC	hdc;
	if(surface->GetDC(&hdc) ==DD_OK)
	{		//̽ Ʈ  
		BitBlt(hdc, 0,0, bmpwidth, bmpheight, hdcbmp, 0,0, SRCCOPY);		//HDC ع
		
		SetBkMode(hdc, TRANSPARENT);
		SetTextColor(hdc, RGB(255, 255, 255));
		TextOut(hdc, 10, 10, TEXT("ѱ Ʈ ߵɱ."), sizeof("ѱ Ʈ ߵɱ.") - 1);
		surface->ReleaseDC(hdc);
	}	//HDC ع
	DeleteDC(hdcbmp);	//Ʈ  ع
	DeleteObject(hbm);

	DDSURFACEDESC2	ddsd;
	memset(&ddsd, 0, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	//̽ ޴ϴ
	surface->Lock(NULL, &ddsd, DDLOCK_WAIT|DDLOCK_SURFACEMEMORYPTR, NULL);
	char	*p=(char *) ddsd.lpSurface;	//»   մϴ
	DWORD	transparent=*(DWORD *) p;
	//̽  մϴ
	surface->Unlock(NULL);	// 
	DDCOLORKEY	ddck;
	ddck.dwColorSpaceLowValue=transparent;
	ddck.dwColorSpaceHighValue=transparent;
	surface->SetColorKey(DDCKEY_SRCBLT, &ddck);
	return surface;
}

LPDIRECTDRAWSURFACE7	create_surface(int width, int height, DWORD caps)
{	//̽ ۼ
	LPDIRECTDRAWSURFACE7	surface;
	DDSURFACEDESC2		ddsd;			//0 ʱȭ

	ZeroMemory(&ddsd, sizeof(ddsd));	//ü  
	ddsd.dwSize=sizeof(ddsd) ;			//ddsCaps, dwWIdth, dwHeight ȿϰ Ѵ
	ddsd.dwFlags=DDSD_CAPS|DDSD_HEIGHT|DDSD_WIDTH; 	//ũ̽
	ddsd.ddsCaps.dwCaps=caps;			//̽  
	ddsd.dwWidth=width;
	ddsd.dwHeight=height; 				//̽ ۼ
	
	ZeroMemory(&surface, sizeof(surface));
	if(dd->CreateSurface(&ddsd, &surface, NULL)!=DD_OK)
		return NULL; 
	return	surface;
}

//---------------------------------------------------
//releaseobject Լ ̽ Ʈ ع
//óѴ
//---------------------------------------------------

BOOL releaseobject(LPDIRECTDRAWSURFACE7 sprite)
{
	if(sprite)	
	{
		sprite->Release();
		return FALSE;
	}
    if(BackSurface)
	{
		BackSurface->Release();
		return FALSE;
	}
	if(MainSurface)
	{
		MainSurface->Release();
		return FALSE;
	}
	return TRUE;
}

void flip(void)
{
	MainSurface->Flip(NULL, DDFLIP_WAIT);
}

void imagerender(LPDIRECTDRAWSURFACE7 sprite)
{
	BackSurface->BltFast(150,150,sprite,NULL,DDBLTFAST_SRCCOLORKEY|DDBLTFAST_WAIT);
}